POJ-3126 Prime Path 解题报告

来源:互联网 发布:大数据数据库有哪些 编辑:程序博客网 时间:2024/05/18 02:00

Description

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices. 
— It is a matter of security to change such things every now and then, to keep the enemy in the dark. 
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know! 
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door. 
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime! 
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds. 
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime. 

Now, the minister of finance, who had been eavesdropping, intervened. 
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound. 
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you? 
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above. 
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Sample Input

3
1033 8179
1373 8017
1033 1033

Sample Output

6
7
0

       题目链接:http://poj.org/problem?id=3126

       解法类型:BFS

       解题思路:这很显然的水题,直接BFS水过,没什么好讲的。但可以优化算法,直接开一个char数组,进行位运算,队列也可以用循环队列等。。。

       算法实现:

//STATUS:C++_AC_16MS_300K#include<stdio.h>#include<memory.h>#include<queue>const int MAXN=10010;int BFS();int num(int pr,int i);int dis[MAXN],vis[MAXN],prime[MAXN],pr1,pr2,d[4]={1000,100,10,1};using namespace std;int main(){//freopen("in.txt","r",stdin);memset(prime,0,sizeof(prime));for(int i=2;i<=110;i++){   //筛素数if(prime[i]==0)     for(int j=i+i;j<MAXN;j+=i){    prime[j]=1;}}int n;scanf("%d",&n);while(n--){memset(dis,0,sizeof(dis));memset(vis,0,sizeof(vis));scanf("%d%d",&pr1,&pr2);int ok=BFS();ok?printf("%d\n",dis[pr2]):printf("Impossible\n");}return 0;}int BFS(){queue<int>q;q.push(pr1);vis[pr1]=1;int pr,npr,t,j;while(!q.empty()){pr=q.front();q.pop();if(pr==pr2)return 1; //search succeed;for(int i=0;i<4;i++){t=num(pr,i);for(j=0;j<10;j++){if(i==0&&j==0)continue;npr=pr+d[i]*(j-t);if(!prime[npr]&&(!vis[npr])){dis[npr]=dis[pr]+1;vis[npr]=1;q.push(npr);}}}}return 0;  //search fail}int num(int pr,int i){int s;for(s=1;i<3;i++)s*=10;return (pr/s)%10;}

原创粉丝点击